// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

library gcm_mojom;

import 'dart:async';

import 'package:mojo/bindings.dart' as bindings;
import 'package:mojo/core.dart' as core;



class _GcmListenerOnMessageReceivedParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  String from = null;
  String jsonMessage = null;

  _GcmListenerOnMessageReceivedParams() : super(kVersions.last.size);

  static _GcmListenerOnMessageReceivedParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _GcmListenerOnMessageReceivedParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _GcmListenerOnMessageReceivedParams result = new _GcmListenerOnMessageReceivedParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.from = decoder0.decodeString(8, false);
    }
    if (mainDataHeader.version >= 0) {
      
      result.jsonMessage = decoder0.decodeString(16, false);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(from, 8, false);
    
    encoder0.encodeString(jsonMessage, 16, false);
  }

  String toString() {
    return "_GcmListenerOnMessageReceivedParams("
           "from: $from" ", "
           "jsonMessage: $jsonMessage" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["from"] = from;
    map["jsonMessage"] = jsonMessage;
    return map;
  }
}


class _GcmServiceRegisterParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  String senderId = null;
  Object listener = null;

  _GcmServiceRegisterParams() : super(kVersions.last.size);

  static _GcmServiceRegisterParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _GcmServiceRegisterParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _GcmServiceRegisterParams result = new _GcmServiceRegisterParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.senderId = decoder0.decodeString(8, false);
    }
    if (mainDataHeader.version >= 0) {
      
      result.listener = decoder0.decodeServiceInterface(16, false, GcmListenerProxy.newFromEndpoint);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(senderId, 8, false);
    
    encoder0.encodeInterface(listener, 16, false);
  }

  String toString() {
    return "_GcmServiceRegisterParams("
           "senderId: $senderId" ", "
           "listener: $listener" ")";
  }

  Map toJson() {
    throw new bindings.MojoCodecError(
        'Object containing handles cannot be encoded to JSON.');
  }
}


class GcmServiceRegisterResponseParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  String token = null;

  GcmServiceRegisterResponseParams() : super(kVersions.last.size);

  static GcmServiceRegisterResponseParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static GcmServiceRegisterResponseParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    GcmServiceRegisterResponseParams result = new GcmServiceRegisterResponseParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.token = decoder0.decodeString(8, false);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(token, 8, false);
  }

  String toString() {
    return "GcmServiceRegisterResponseParams("
           "token: $token" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["token"] = token;
    return map;
  }
}


class _GcmServiceSubscribeTopicsParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  String token = null;
  List<String> topics = null;

  _GcmServiceSubscribeTopicsParams() : super(kVersions.last.size);

  static _GcmServiceSubscribeTopicsParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _GcmServiceSubscribeTopicsParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _GcmServiceSubscribeTopicsParams result = new _GcmServiceSubscribeTopicsParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.token = decoder0.decodeString(8, false);
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(16, false);
      {
        var si1 = decoder1.decodeDataHeaderForPointerArray(bindings.kUnspecifiedArrayLength);
        result.topics = new List<String>(si1.numElements);
        for (int i1 = 0; i1 < si1.numElements; ++i1) {
          
          result.topics[i1] = decoder1.decodeString(bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i1, false);
        }
      }
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(token, 8, false);
    
    if (topics == null) {
      encoder0.encodeNullPointer(16, false);
    } else {
      var encoder1 = encoder0.encodePointerArray(topics.length, 16, bindings.kUnspecifiedArrayLength);
      for (int i0 = 0; i0 < topics.length; ++i0) {
        
        encoder1.encodeString(topics[i0], bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i0, false);
      }
    }
  }

  String toString() {
    return "_GcmServiceSubscribeTopicsParams("
           "token: $token" ", "
           "topics: $topics" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["token"] = token;
    map["topics"] = topics;
    return map;
  }
}


class _GcmServiceUnsubscribeTopicsParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  String token = null;
  List<String> topics = null;

  _GcmServiceUnsubscribeTopicsParams() : super(kVersions.last.size);

  static _GcmServiceUnsubscribeTopicsParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _GcmServiceUnsubscribeTopicsParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _GcmServiceUnsubscribeTopicsParams result = new _GcmServiceUnsubscribeTopicsParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.token = decoder0.decodeString(8, false);
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(16, false);
      {
        var si1 = decoder1.decodeDataHeaderForPointerArray(bindings.kUnspecifiedArrayLength);
        result.topics = new List<String>(si1.numElements);
        for (int i1 = 0; i1 < si1.numElements; ++i1) {
          
          result.topics[i1] = decoder1.decodeString(bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i1, false);
        }
      }
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(token, 8, false);
    
    if (topics == null) {
      encoder0.encodeNullPointer(16, false);
    } else {
      var encoder1 = encoder0.encodePointerArray(topics.length, 16, bindings.kUnspecifiedArrayLength);
      for (int i0 = 0; i0 < topics.length; ++i0) {
        
        encoder1.encodeString(topics[i0], bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i0, false);
      }
    }
  }

  String toString() {
    return "_GcmServiceUnsubscribeTopicsParams("
           "token: $token" ", "
           "topics: $topics" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["token"] = token;
    map["topics"] = topics;
    return map;
  }
}

const int _GcmListener_onMessageReceivedName = 0;

abstract class GcmListener {
  static const String serviceName = "gcm::GcmListener";
  void onMessageReceived(String from, String jsonMessage);
}


class _GcmListenerProxyImpl extends bindings.Proxy {
  _GcmListenerProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _GcmListenerProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _GcmListenerProxyImpl.unbound() : super.unbound();

  static _GcmListenerProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _GcmListenerProxyImpl"));
    return new _GcmListenerProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_GcmListenerProxyImpl($superString)";
  }
}


class _GcmListenerProxyCalls implements GcmListener {
  _GcmListenerProxyImpl _proxyImpl;

  _GcmListenerProxyCalls(this._proxyImpl);
    void onMessageReceived(String from, String jsonMessage) {
      if (!_proxyImpl.isBound) {
        _proxyImpl.proxyError("The Proxy is closed.");
        return;
      }
      var params = new _GcmListenerOnMessageReceivedParams();
      params.from = from;
      params.jsonMessage = jsonMessage;
      _proxyImpl.sendMessage(params, _GcmListener_onMessageReceivedName);
    }
}


class GcmListenerProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  GcmListener ptr;

  GcmListenerProxy(_GcmListenerProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _GcmListenerProxyCalls(proxyImpl);

  GcmListenerProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _GcmListenerProxyImpl.fromEndpoint(endpoint) {
    ptr = new _GcmListenerProxyCalls(impl);
  }

  GcmListenerProxy.fromHandle(core.MojoHandle handle) :
      impl = new _GcmListenerProxyImpl.fromHandle(handle) {
    ptr = new _GcmListenerProxyCalls(impl);
  }

  GcmListenerProxy.unbound() :
      impl = new _GcmListenerProxyImpl.unbound() {
    ptr = new _GcmListenerProxyCalls(impl);
  }

  factory GcmListenerProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    GcmListenerProxy p = new GcmListenerProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static GcmListenerProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For GcmListenerProxy"));
    return new GcmListenerProxy.fromEndpoint(endpoint);
  }

  String get serviceName => GcmListener.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "GcmListenerProxy($impl)";
  }
}


class GcmListenerStub extends bindings.Stub {
  GcmListener _impl = null;

  GcmListenerStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  GcmListenerStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  GcmListenerStub.unbound() : super.unbound();

  static GcmListenerStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For GcmListenerStub"));
    return new GcmListenerStub.fromEndpoint(endpoint);
  }



  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _GcmListener_onMessageReceivedName:
        var params = _GcmListenerOnMessageReceivedParams.deserialize(
            message.payload);
        _impl.onMessageReceived(params.from, params.jsonMessage);
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  GcmListener get impl => _impl;
  set impl(GcmListener d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "GcmListenerStub($superString)";
  }

  int get version => 0;
}

const int _GcmService_registerName = 0;
const int _GcmService_subscribeTopicsName = 1;
const int _GcmService_unsubscribeTopicsName = 2;

abstract class GcmService {
  static const String serviceName = "gcm::GcmService";
  dynamic register(String senderId,Object listener,[Function responseFactory = null]);
  void subscribeTopics(String token, List<String> topics);
  void unsubscribeTopics(String token, List<String> topics);
}


class _GcmServiceProxyImpl extends bindings.Proxy {
  _GcmServiceProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _GcmServiceProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _GcmServiceProxyImpl.unbound() : super.unbound();

  static _GcmServiceProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _GcmServiceProxyImpl"));
    return new _GcmServiceProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      case _GcmService_registerName:
        var r = GcmServiceRegisterResponseParams.deserialize(
            message.payload);
        if (!message.header.hasRequestId) {
          proxyError("Expected a message with a valid request Id.");
          return;
        }
        Completer c = completerMap[message.header.requestId];
        if (c == null) {
          proxyError(
              "Message had unknown request Id: ${message.header.requestId}");
          return;
        }
        completerMap.remove(message.header.requestId);
        if (c.isCompleted) {
          proxyError("Response completer already completed");
          return;
        }
        c.complete(r);
        break;
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_GcmServiceProxyImpl($superString)";
  }
}


class _GcmServiceProxyCalls implements GcmService {
  _GcmServiceProxyImpl _proxyImpl;

  _GcmServiceProxyCalls(this._proxyImpl);
    dynamic register(String senderId,Object listener,[Function responseFactory = null]) {
      var params = new _GcmServiceRegisterParams();
      params.senderId = senderId;
      params.listener = listener;
      return _proxyImpl.sendMessageWithRequestId(
          params,
          _GcmService_registerName,
          -1,
          bindings.MessageHeader.kMessageExpectsResponse);
    }
    void subscribeTopics(String token, List<String> topics) {
      if (!_proxyImpl.isBound) {
        _proxyImpl.proxyError("The Proxy is closed.");
        return;
      }
      var params = new _GcmServiceSubscribeTopicsParams();
      params.token = token;
      params.topics = topics;
      _proxyImpl.sendMessage(params, _GcmService_subscribeTopicsName);
    }
    void unsubscribeTopics(String token, List<String> topics) {
      if (!_proxyImpl.isBound) {
        _proxyImpl.proxyError("The Proxy is closed.");
        return;
      }
      var params = new _GcmServiceUnsubscribeTopicsParams();
      params.token = token;
      params.topics = topics;
      _proxyImpl.sendMessage(params, _GcmService_unsubscribeTopicsName);
    }
}


class GcmServiceProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  GcmService ptr;

  GcmServiceProxy(_GcmServiceProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _GcmServiceProxyCalls(proxyImpl);

  GcmServiceProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _GcmServiceProxyImpl.fromEndpoint(endpoint) {
    ptr = new _GcmServiceProxyCalls(impl);
  }

  GcmServiceProxy.fromHandle(core.MojoHandle handle) :
      impl = new _GcmServiceProxyImpl.fromHandle(handle) {
    ptr = new _GcmServiceProxyCalls(impl);
  }

  GcmServiceProxy.unbound() :
      impl = new _GcmServiceProxyImpl.unbound() {
    ptr = new _GcmServiceProxyCalls(impl);
  }

  factory GcmServiceProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    GcmServiceProxy p = new GcmServiceProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static GcmServiceProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For GcmServiceProxy"));
    return new GcmServiceProxy.fromEndpoint(endpoint);
  }

  String get serviceName => GcmService.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "GcmServiceProxy($impl)";
  }
}


class GcmServiceStub extends bindings.Stub {
  GcmService _impl = null;

  GcmServiceStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  GcmServiceStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  GcmServiceStub.unbound() : super.unbound();

  static GcmServiceStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For GcmServiceStub"));
    return new GcmServiceStub.fromEndpoint(endpoint);
  }


  GcmServiceRegisterResponseParams _GcmServiceRegisterResponseParamsFactory(String token) {
    var mojo_factory_result = new GcmServiceRegisterResponseParams();
    mojo_factory_result.token = token;
    return mojo_factory_result;
  }

  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _GcmService_registerName:
        var params = _GcmServiceRegisterParams.deserialize(
            message.payload);
        var response = _impl.register(params.senderId,params.listener,_GcmServiceRegisterResponseParamsFactory);
        if (response is Future) {
          return response.then((response) {
            if (response != null) {
              return buildResponseWithId(
                  response,
                  _GcmService_registerName,
                  message.header.requestId,
                  bindings.MessageHeader.kMessageIsResponse);
            }
          });
        } else if (response != null) {
          return buildResponseWithId(
              response,
              _GcmService_registerName,
              message.header.requestId,
              bindings.MessageHeader.kMessageIsResponse);
        }
        break;
      case _GcmService_subscribeTopicsName:
        var params = _GcmServiceSubscribeTopicsParams.deserialize(
            message.payload);
        _impl.subscribeTopics(params.token, params.topics);
        break;
      case _GcmService_unsubscribeTopicsName:
        var params = _GcmServiceUnsubscribeTopicsParams.deserialize(
            message.payload);
        _impl.unsubscribeTopics(params.token, params.topics);
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  GcmService get impl => _impl;
  set impl(GcmService d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "GcmServiceStub($superString)";
  }

  int get version => 0;
}


