// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

library raw_keyboard_mojom;

import 'dart:async';

import 'package:mojo/bindings.dart' as bindings;
import 'package:mojo/core.dart' as core;
import 'package:sky_services/sky/input_event.mojom.dart' as input_event_mojom;



class _RawKeyboardListenerOnKeyParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  input_event_mojom.InputEvent event = null;

  _RawKeyboardListenerOnKeyParams() : super(kVersions.last.size);

  static _RawKeyboardListenerOnKeyParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _RawKeyboardListenerOnKeyParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _RawKeyboardListenerOnKeyParams result = new _RawKeyboardListenerOnKeyParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(8, false);
      result.event = input_event_mojom.InputEvent.decode(decoder1);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeStruct(event, 8, false);
  }

  String toString() {
    return "_RawKeyboardListenerOnKeyParams("
           "event: $event" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["event"] = event;
    return map;
  }
}


class _RawKeyboardServiceAddListenerParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  Object listener = null;

  _RawKeyboardServiceAddListenerParams() : super(kVersions.last.size);

  static _RawKeyboardServiceAddListenerParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _RawKeyboardServiceAddListenerParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _RawKeyboardServiceAddListenerParams result = new _RawKeyboardServiceAddListenerParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.listener = decoder0.decodeServiceInterface(8, false, RawKeyboardListenerProxy.newFromEndpoint);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeInterface(listener, 8, false);
  }

  String toString() {
    return "_RawKeyboardServiceAddListenerParams("
           "listener: $listener" ")";
  }

  Map toJson() {
    throw new bindings.MojoCodecError(
        'Object containing handles cannot be encoded to JSON.');
  }
}

const int _RawKeyboardListener_onKeyName = 0;

abstract class RawKeyboardListener {
  static const String serviceName = "raw_keyboard::RawKeyboardListener";
  void onKey(input_event_mojom.InputEvent event);
}


class _RawKeyboardListenerProxyImpl extends bindings.Proxy {
  _RawKeyboardListenerProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _RawKeyboardListenerProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _RawKeyboardListenerProxyImpl.unbound() : super.unbound();

  static _RawKeyboardListenerProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _RawKeyboardListenerProxyImpl"));
    return new _RawKeyboardListenerProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_RawKeyboardListenerProxyImpl($superString)";
  }
}


class _RawKeyboardListenerProxyCalls implements RawKeyboardListener {
  _RawKeyboardListenerProxyImpl _proxyImpl;

  _RawKeyboardListenerProxyCalls(this._proxyImpl);
    void onKey(input_event_mojom.InputEvent event) {
      if (!_proxyImpl.isBound) {
        _proxyImpl.proxyError("The Proxy is closed.");
        return;
      }
      var params = new _RawKeyboardListenerOnKeyParams();
      params.event = event;
      _proxyImpl.sendMessage(params, _RawKeyboardListener_onKeyName);
    }
}


class RawKeyboardListenerProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  RawKeyboardListener ptr;

  RawKeyboardListenerProxy(_RawKeyboardListenerProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _RawKeyboardListenerProxyCalls(proxyImpl);

  RawKeyboardListenerProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _RawKeyboardListenerProxyImpl.fromEndpoint(endpoint) {
    ptr = new _RawKeyboardListenerProxyCalls(impl);
  }

  RawKeyboardListenerProxy.fromHandle(core.MojoHandle handle) :
      impl = new _RawKeyboardListenerProxyImpl.fromHandle(handle) {
    ptr = new _RawKeyboardListenerProxyCalls(impl);
  }

  RawKeyboardListenerProxy.unbound() :
      impl = new _RawKeyboardListenerProxyImpl.unbound() {
    ptr = new _RawKeyboardListenerProxyCalls(impl);
  }

  factory RawKeyboardListenerProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    RawKeyboardListenerProxy p = new RawKeyboardListenerProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static RawKeyboardListenerProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For RawKeyboardListenerProxy"));
    return new RawKeyboardListenerProxy.fromEndpoint(endpoint);
  }

  String get serviceName => RawKeyboardListener.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "RawKeyboardListenerProxy($impl)";
  }
}


class RawKeyboardListenerStub extends bindings.Stub {
  RawKeyboardListener _impl = null;

  RawKeyboardListenerStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  RawKeyboardListenerStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  RawKeyboardListenerStub.unbound() : super.unbound();

  static RawKeyboardListenerStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For RawKeyboardListenerStub"));
    return new RawKeyboardListenerStub.fromEndpoint(endpoint);
  }



  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _RawKeyboardListener_onKeyName:
        var params = _RawKeyboardListenerOnKeyParams.deserialize(
            message.payload);
        _impl.onKey(params.event);
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  RawKeyboardListener get impl => _impl;
  set impl(RawKeyboardListener d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "RawKeyboardListenerStub($superString)";
  }

  int get version => 0;
}

const int _RawKeyboardService_addListenerName = 0;

abstract class RawKeyboardService {
  static const String serviceName = "raw_keyboard::RawKeyboardService";
  void addListener(Object listener);
}


class _RawKeyboardServiceProxyImpl extends bindings.Proxy {
  _RawKeyboardServiceProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _RawKeyboardServiceProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _RawKeyboardServiceProxyImpl.unbound() : super.unbound();

  static _RawKeyboardServiceProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _RawKeyboardServiceProxyImpl"));
    return new _RawKeyboardServiceProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_RawKeyboardServiceProxyImpl($superString)";
  }
}


class _RawKeyboardServiceProxyCalls implements RawKeyboardService {
  _RawKeyboardServiceProxyImpl _proxyImpl;

  _RawKeyboardServiceProxyCalls(this._proxyImpl);
    void addListener(Object listener) {
      if (!_proxyImpl.isBound) {
        _proxyImpl.proxyError("The Proxy is closed.");
        return;
      }
      var params = new _RawKeyboardServiceAddListenerParams();
      params.listener = listener;
      _proxyImpl.sendMessage(params, _RawKeyboardService_addListenerName);
    }
}


class RawKeyboardServiceProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  RawKeyboardService ptr;

  RawKeyboardServiceProxy(_RawKeyboardServiceProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _RawKeyboardServiceProxyCalls(proxyImpl);

  RawKeyboardServiceProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _RawKeyboardServiceProxyImpl.fromEndpoint(endpoint) {
    ptr = new _RawKeyboardServiceProxyCalls(impl);
  }

  RawKeyboardServiceProxy.fromHandle(core.MojoHandle handle) :
      impl = new _RawKeyboardServiceProxyImpl.fromHandle(handle) {
    ptr = new _RawKeyboardServiceProxyCalls(impl);
  }

  RawKeyboardServiceProxy.unbound() :
      impl = new _RawKeyboardServiceProxyImpl.unbound() {
    ptr = new _RawKeyboardServiceProxyCalls(impl);
  }

  factory RawKeyboardServiceProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    RawKeyboardServiceProxy p = new RawKeyboardServiceProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static RawKeyboardServiceProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For RawKeyboardServiceProxy"));
    return new RawKeyboardServiceProxy.fromEndpoint(endpoint);
  }

  String get serviceName => RawKeyboardService.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "RawKeyboardServiceProxy($impl)";
  }
}


class RawKeyboardServiceStub extends bindings.Stub {
  RawKeyboardService _impl = null;

  RawKeyboardServiceStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  RawKeyboardServiceStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  RawKeyboardServiceStub.unbound() : super.unbound();

  static RawKeyboardServiceStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For RawKeyboardServiceStub"));
    return new RawKeyboardServiceStub.fromEndpoint(endpoint);
  }



  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _RawKeyboardService_addListenerName:
        var params = _RawKeyboardServiceAddListenerParams.deserialize(
            message.payload);
        _impl.addListener(params.listener);
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  RawKeyboardService get impl => _impl;
  set impl(RawKeyboardService d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "RawKeyboardServiceStub($superString)";
  }

  int get version => 0;
}


