// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

library update_service_mojom;

import 'dart:async';

import 'package:mojo/bindings.dart' as bindings;
import 'package:mojo/core.dart' as core;



class _UpdateServiceNotifyUpdateCheckCompleteParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(8, 0)
  ];

  _UpdateServiceNotifyUpdateCheckCompleteParams() : super(kVersions.last.size);

  static _UpdateServiceNotifyUpdateCheckCompleteParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _UpdateServiceNotifyUpdateCheckCompleteParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _UpdateServiceNotifyUpdateCheckCompleteParams result = new _UpdateServiceNotifyUpdateCheckCompleteParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    encoder.getStructEncoderAtOffset(kVersions.last);
  }

  String toString() {
    return "_UpdateServiceNotifyUpdateCheckCompleteParams("")";
  }

  Map toJson() {
    Map map = new Map();
    return map;
  }
}

const int _UpdateService_notifyUpdateCheckCompleteName = 0;

abstract class UpdateService {
  static const String serviceName = "updater::UpdateService";
  void notifyUpdateCheckComplete();
}


class _UpdateServiceProxyImpl extends bindings.Proxy {
  _UpdateServiceProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _UpdateServiceProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _UpdateServiceProxyImpl.unbound() : super.unbound();

  static _UpdateServiceProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _UpdateServiceProxyImpl"));
    return new _UpdateServiceProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_UpdateServiceProxyImpl($superString)";
  }
}


class _UpdateServiceProxyCalls implements UpdateService {
  _UpdateServiceProxyImpl _proxyImpl;

  _UpdateServiceProxyCalls(this._proxyImpl);
    void notifyUpdateCheckComplete() {
      if (!_proxyImpl.isBound) {
        _proxyImpl.proxyError("The Proxy is closed.");
        return;
      }
      var params = new _UpdateServiceNotifyUpdateCheckCompleteParams();
      _proxyImpl.sendMessage(params, _UpdateService_notifyUpdateCheckCompleteName);
    }
}


class UpdateServiceProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  UpdateService ptr;

  UpdateServiceProxy(_UpdateServiceProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _UpdateServiceProxyCalls(proxyImpl);

  UpdateServiceProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _UpdateServiceProxyImpl.fromEndpoint(endpoint) {
    ptr = new _UpdateServiceProxyCalls(impl);
  }

  UpdateServiceProxy.fromHandle(core.MojoHandle handle) :
      impl = new _UpdateServiceProxyImpl.fromHandle(handle) {
    ptr = new _UpdateServiceProxyCalls(impl);
  }

  UpdateServiceProxy.unbound() :
      impl = new _UpdateServiceProxyImpl.unbound() {
    ptr = new _UpdateServiceProxyCalls(impl);
  }

  factory UpdateServiceProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    UpdateServiceProxy p = new UpdateServiceProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static UpdateServiceProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For UpdateServiceProxy"));
    return new UpdateServiceProxy.fromEndpoint(endpoint);
  }

  String get serviceName => UpdateService.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "UpdateServiceProxy($impl)";
  }
}


class UpdateServiceStub extends bindings.Stub {
  UpdateService _impl = null;

  UpdateServiceStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  UpdateServiceStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  UpdateServiceStub.unbound() : super.unbound();

  static UpdateServiceStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For UpdateServiceStub"));
    return new UpdateServiceStub.fromEndpoint(endpoint);
  }



  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _UpdateService_notifyUpdateCheckCompleteName:
        var params = _UpdateServiceNotifyUpdateCheckCompleteParams.deserialize(
            message.payload);
        _impl.notifyUpdateCheckComplete();
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  UpdateService get impl => _impl;
  set impl(UpdateService d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "UpdateServiceStub($superString)";
  }

  int get version => 0;
}


